##--------------------------------------------------------------------------------------------------------
## PROJECT : The effect of spatial resolution on SDM efficiency
## SCRIPT : Function to compute the contribution of each variable to the linear predictor
##
## Author : Charlotte Lambert
##--------------------------------------------------------------------------------------------------------


contrib_func <- function(model, data){
  ## calcul de la part de chaque terme 
  # extraction de la part de chaque terme par pixel
  pred <- predict(model, newdata = data, type = "terms") # matrice avec la valeur du predicteur linaire pour chaque terme
  
  # calcul de la part relative de chaque terme par ligne (Attention : mettre en valeur absolue avec abs())
  DF <- as.data.frame(pred)
  for(m in 1:nrow(pred)){ 
    for(n in 1:ncol(pred)){
      DF[m,n] <- abs(pred[m,n]) / sum(abs(pred[m,]))
    }
  }
  
  # calcul de la part relative moyenne par terme (somme de la colonne/nombre de ligne)
  colsum <- NULL
  for(n in 1:ncol(DF)){
    colsum <- cbind(colsum, apply(DF[n], MARGIN = 2, FUN = mean, na.rm = T))
  }
  colnames(colsum) <- colnames(DF)
  rownames(colsum) <- 1
  
  # return result
  return(colsum)
}
